/* Borland-style console front end to consl11 functions */
/* DTF */

#include <console.h>

/* The following following console input functions must be provided elsewhere:
    cgets
    cscanf
    getch
    getche
    ungetch
    kbhit
*/
#include "/bin/watcom/h/conio.h"

/* dark colors */
#define BLACK CON_BLACK
#define BLUE CON_BLUE
#define GREEN CON_GREEN
#define CYAN CON_CYAN
#define RED CON_RED
#define MAGENTA CON_MAGENTA
#define BROWN CON_BROWN
#define LIGHTGRAY CON_LIGHTGRAY

/* light colors */
#define DARKGRAY CON_DARKGRAY
#define LIGHTBLUE CON_LIGHTBLUE
#define LIGHTGREEN CON_LIGHTGREEN
#define LIGHTCYAN CON_LIGHTCYAN
#define LIGHTRED CON_LIGHTRED
#define LIGHTMAGENTA CON_LIGHTMAGENTA
#define YELLOW CON_YELLOW
#define WHITE CON_WHITE

#define _NOCURSOR      0
#define _SOLIDCURSOR   CON_CURSOR_FULL
#define _NORMALCURSOR  CON_CURSOR_NORMAL

#define BLINK CON_BLINK

struct text_info {
    int winleft, wintop, winright, winbottom;
    int screenwidth, screenheight;
    unsigned char attribute;
    unsigned char curx, cury;
    unsigned char normattr;
};

#define cinit() CON_init()  /* No Borland equivalent but must be called first */

#define textbackground(bg) { CON_setBackColor(bg); \
                CON_setBackground(CON_makeAttr(CON_getAttr() & 0xf,bg),' '); }
#define textcolor(c)    CON_setForeColor(c)
#define textattr(a)     {CON_setAttr(a); CON_setBackground(a,' ');}
#define highvideo()     CON_setForeColor(CON_getAttr() | 8)
#define lowvideo()      CON_setForeColor(CON_getAttr() & 7)
#define normvideo()     CON_setForeColor(7)
#define clrscr()        CON_clrscr()
#define clreol()        CON_clreol()
#define insline()       CON_insline()
#define delline()       CON_delline()
#define putch(c)        CON_putc(c)
#define cprintf         CON_printf  /* handles \r differently */
#define cputs(s)        CON_puts(s)
#define gotoxy(x,y)     CON_gotoxy((x)-1,(y)-1)
#define wherex()        (CON_wherex() + 1)
#define wherey()        (CON_wherey() + 1)
#define window(l,t,r,b) CON_setWindow((l)-1,(t)-1,(r)-1,(b)-1)
#define movetext(l,t,r,b,dl,dt) CON_moveText((l)-1,(t)-1,(r)-1,(b)-1,(dl)-1,(dt)-1)
#define gettext(l,t,r,b,d)  CON_saveText((l)-1,(t)-1,(r)-1,(b)-1,d)
#define _setcursortype(t)   {if ((t) == _NOCURSOR) CON_cursorOff(); \
                             else CON_setCursor(t); }
#define gettextinfo(p) { \
    (p)->screenwidth = CON_screenWidth(); \
    (p)->screenheight = CON_screenHeight(); \
    (p)->curx = CON_wherex() + 1; \
    (p)->cury = CON_wherey() + 1; \
    (p)->attribute = CON_getAttr(); \
    (p)->normattr = 7; \
    CON_getWindow(&((p)->winleft), &((p)->wintop), &((p)->winright), &((p)->winbottom)); \
    ++((p)->winleft), ++((p)->wintop), ++((p)->winright), ++((p)->winbottom); \
}
