/* Borland-style conio wrappers for Watcom text functions */

#include <stdarg.h>
#include <graph.h>

/* cprintf function */
int _outprintf(const char *format, ...)
{
    int retCode;
    va_list args;
    char str[1024];

    va_start(args, format);
    retCode = vsprintf(str, format, args);
    va_end(args);
    _outtext(str);		/* write using Watcom's text print function */
    return retCode;
}

void _insline(void) {
	short l,t,r,b;
	struct rccoord pos;
	_gettextwindow(&l,&t,&r,&b);	/* get current window dimensions */
	pos = _gettextposition();		/* get current cursor position */
	_settextwindow(pos.row,t,r,b);	/* create smaller window */
	_scrolltextwindow(_GSCROLLDOWN);		/* scroll window down */
	_settextwindow(l,t,r,b);				/* restore window */
	_settextposition(pos.row,pos.col);		/* restore cursor position */
}

void _delline(void) {
	short l,t,r,b;
	struct rccoord pos;
	_gettextwindow(&l,&t,&r,&b);	/* get current window dimensions */
	pos = _gettextposition();		/* get current cursor position */
	_settextwindow(pos.row,t,r,b);	/* create smaller window */
	_scrolltextwindow(_GSCROLLUP);			/* scroll window up */
	_settextwindow(l,t,r,b);				/* restore window */
	_settextposition(pos.row,pos.col);		/* restore cursor position */
}

void _clreol(void) {
	short l,t,r,b;
	struct rccoord pos;
	_gettextwindow(&l,&t,&r,&b);	/* get current window dimensions */
	pos = _gettextposition();		/* get current cursor position */
	_settextwindow(pos.row,pos.col,pos.row,b);	/* create one line window */
	_clearscreen(_GWINDOW);					/* clear window */
	_settextwindow(l,t,r,b);				/* restore window */
	_settextposition(pos.row,pos.col);		/* restore cursor position */
}

